# all files / ol/ imagecanvas.js

39.29% Statements 11/28
0% Branches 0/8
0% Functions 0/5
39.29% Lines 11/28

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    1071×

    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
     goog.provide('ol.ImageCanvas');

    goog.require('goog.asserts');
    goog.require('ol.ImageBase');
    goog.require('ol.ImageState');

    /**
     * @constructor
     * @extends {ol.ImageBase}
     * @param {ol.Extent} extent Extent.
     * @param {number} resolution Resolution.
     * @param {number} pixelRatio Pixel ratio.
     * @param {Array.<ol.Attribution>} attributions Attributions.
     * @param {HTMLCanvasElement} canvas Canvas.
     * @param {ol.ImageCanvasLoader=} opt_loader Optional loader function to
     *     support asynchronous canvas drawing.
     */
    ol.ImageCanvas = function(extent, resolution, pixelRatio, attributions,
        canvas, opt_loader) {

      /**
       * Optional canvas loader function.
       * @type {?ol.ImageCanvasLoader}
       * @private
       */
      this.loader_ = opt_loader !== undefined ? opt_loader : null;

      var state = opt_loader !== undefined ?
          ol.ImageState.IDLE : ol.ImageState.LOADED;

      goog.base(this, extent, [resolution, resolution], pixelRatio, state,
          attributions);

      /**
       * @private
       * @type {HTMLCanvasElement}
       */
      this.canvas_ = canvas;

      /**
       * @private
       * @type {Error}
       */
      this.error_ = null;

    };
    goog.inherits(ol.ImageCanvas, ol.ImageBase);

    /**
     * Get any error associated with asynchronous rendering.
     * @return {Error} Any error that occurred during rendering.
     */
    ol.ImageCanvas.prototype.getError = function() {
      return this.error_;
    };

    /**
     * Handle async drawing complete.
     * @param {Error} err Any error during drawing.
     * @private
     */
    ol.ImageCanvas.prototype.handleLoad_ = function(err) {
      if (err) {
        this.error_ = err;
        this.state = ol.ImageState.ERROR;
      } else {
        this.state = ol.ImageState.LOADED;
      }
      this.changed();
    };

    /**
     * Trigger drawing on canvas.
     */
    ol.ImageCanvas.prototype.load = function() {
      if (this.state == ol.ImageState.IDLE) {
        goog.asserts.assert(this.loader_, 'this.loader_ must be set');
        this.state = ol.ImageState.LOADING;
        this.changed();
        this.loader_(goog.bind(this.handleLoad_, this));
      }
    };

    /**
     * @inheritDoc
     */
    ol.ImageCanvas.prototype.getImage = function(opt_context) {
      return this.canvas_;
    };

    /**
     * A function that is called to trigger asynchronous canvas drawing.  It is
     * called with a "done" callback that should be called when drawing is done.
     * If any error occurs during drawing, the "done" callback should be called with
     * that error.
     *
     * @typedef {function(function(Error))}
     */
    ol.ImageCanvasLoader;